Index: src/Fl_Group.cxx
===================================================================
--- src/Fl_Group.cxx	(revision 6732)
+++ src/Fl_Group.cxx	(working copy)
@@ -764,6 +764,180 @@
   widget.draw_label(X,Y,W,H,(Fl_Align)a);
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+long
+Fl_Group::msaa_child_id(Fl_Widget* o) const
+{
+  if (o == this)  return 0;
+  int idx = find(o);
+  if (idx < children())  return idx + 1;
+  return -1;
+}
+
+
+Fl_Widget*
+Fl_Group::msaa_child_widget(long id) const
+{
+  if (id == 0)  return (Fl_Widget*)this;
+  if ((id >= 1) && (id <= children()))  return child(id - 1);
+  return NULL;
+}
+
+
+Fl_Msaa_Proxy*
+Fl_Group::msaa_child(long id)
+{
+  if (id == 0)  return Fl_Widget::msaa_child(0);
+  Fl_Widget* o = msaa_child_widget(id);
+  if (o)  return o->msaa_proxy();
+  return NULL;
+}
+
+
+bool
+Fl_Group::msaa_name(long id, BSTR* bstr)
+{
+  if (id == 0)  return Fl_Widget::msaa_name(0, bstr);
+  Fl_Widget* o = msaa_child_widget(id);
+  if (o)  return o->msaa_name(0, bstr);
+  return false;
+}
+
+
+bool
+Fl_Group::msaa_value(long id, BSTR* bstr)
+{
+  if (id == 0)  return Fl_Widget::msaa_value(0, bstr);
+  Fl_Widget* o = msaa_child_widget(id);
+  if (o)  return o->msaa_value(0, bstr);
+  return false;
+}
+
+
+bool
+Fl_Group::msaa_description(long id, BSTR* bstr)
+{
+  if (id == 0)  return Fl_Widget::msaa_description(0, bstr);
+  Fl_Widget* o = msaa_child_widget(id);
+  if (o)  return o->msaa_description(0, bstr);
+  return false;
+}
+
+
+long
+Fl_Group::msaa_role(long id)
+{
+  if (id == 0)  return ROLE_SYSTEM_GROUPING;
+  Fl_Widget* o = msaa_child_widget(id);
+  if (o)  return o->msaa_role(0);
+  return Fl_Widget::msaa_role(0);
+}
+
+
+long
+Fl_Group::msaa_state(long id)
+{
+  if (id == 0)  return Fl_Widget::msaa_state(0);
+  Fl_Widget* o = msaa_child_widget(id);
+  if (o)  return o->msaa_state(0);
+  return Fl_Widget::msaa_state(0);
+}
+
+
+bool
+Fl_Group::msaa_help(long id, BSTR* bstr)
+{
+  if (id == 0)  return Fl_Widget::msaa_help(0, bstr);
+  Fl_Widget* o = msaa_child_widget(id);
+  if (o)  return o->msaa_help(0, bstr);
+  return false;
+}
+
+
+bool
+Fl_Group::msaa_help_topic(long id, BSTR* bstr, long* num)
+{
+  if (id == 0)  return Fl_Widget::msaa_help_topic(0, bstr, num);
+  Fl_Widget* o = msaa_child_widget(id);
+  if (o)  return o->msaa_help_topic(0, bstr, num);
+  return false;
+}
+
+
+bool
+Fl_Group::msaa_shortcut(long id, BSTR* bstr)
+{
+  if (id == 0)  return Fl_Widget::msaa_shortcut(0, bstr);
+  Fl_Widget* o = msaa_child_widget(id);
+  if (o)  return o->msaa_shortcut(0, bstr);
+  return false;
+}
+
+
+long
+Fl_Group::msaa_focus()
+{
+  return msaa_child_id(Fl::focus());
+}
+
+
+bool
+Fl_Group::msaa_action(long id, BSTR* bstr)
+{
+  if (id == 0)  return Fl_Widget::msaa_action(0, bstr);
+  Fl_Widget* o = msaa_child_widget(id);
+  if (o)  return o->msaa_action(0, bstr);
+  return false;
+}
+
+
+bool
+Fl_Group::msaa_do_select(long id, long flags)
+{
+  if (id == 0)  return Fl_Widget::msaa_do_select(0, flags);
+  Fl_Widget* o = msaa_child_widget(id);
+  if (o)  return o->msaa_do_select(0, flags);
+  return false;
+}
+
+
+bool
+Fl_Group::msaa_location(long id, long* X, long* Y, long* W, long* H)
+{
+  if (id == 0)  return Fl_Widget::msaa_location(0, X, Y, W, H);
+  Fl_Widget* o = msaa_child_widget(id);
+  if (o)  return o->msaa_location(0, X, Y, W, H);
+  return false;
+}
+
+
+bool
+Fl_Group::msaa_do_action(long id)
+{
+  if (id == 0)  return Fl_Widget::msaa_do_action(0);
+  Fl_Widget* o = msaa_child_widget(id);
+  if (o)  return o->msaa_do_action(0);
+  return false;
+}
+
+
+bool
+Fl_Group::msaa_put_value(long id, const char* str)
+{
+  if (id == 0)  return Fl_Widget::msaa_put_value(0, str);
+  Fl_Widget* o = msaa_child_widget(id);
+  if (o)  return o->msaa_put_value(0, str);
+  return false;
+}
+#endif // FL_HAVE_MSAA
+
+
 //
 // End of "$Id$".
 //
Index: src/Fl.cxx
===================================================================
--- src/Fl.cxx	(revision 6732)
+++ src/Fl.cxx	(working copy)
@@ -748,6 +748,9 @@
       fl_oldfocus = p;
     }
     e_number = old_event;
+#ifdef FL_HAVE_MSAA
+    if (o)  o->msaa_on_focus();
+#endif // FL_HAVE_MSAA
   }
 }
 
